class Counter {
      private int c = 0;
      public synchronized void increment() {
	  c++;
      }
      public int value() {
	  return c;
      }
}

class ThreadCounter extends Thread {
      public static int calls = 0;
      public Counter mycounter;
      public ThreadCounter (String str, Counter count) {
	  super(str);
	  this.mycounter = count;
      }
      public void run() {
	  for (int i = 0; i < 10000; i++) {
	      mycounter.increment();
	      calls++;
	      System.out.println(getName() + ": calls = "+calls+
				 ", counter = " + mycounter.value());
	  }
	  System.out.println("DONE! " + getName());
      }
} 

public class MemoryInconsistency {
    public static void main (String args[]) {
	  Counter c1 = new Counter();

	  ThreadCounter t1 = new ThreadCounter("1", c1);
	  ThreadCounter t2 = new ThreadCounter("2", c1);
	  ThreadCounter t3 = new ThreadCounter("3", c1);

	  t1.setPriority(Thread.NORM_PRIORITY+2);
	  t1.start();
	  t2.start();
	  t3.start();
    }

}